Index: src/parser.cpp
===================================================================
--- src/parser.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/parser.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -7,4 +7,6 @@
 // ======================================= INCLUDES ==========================================
 
+#include <cstring>
+
 #include "helpers.hpp"
 #include "memoryallocator.hpp"
@@ -30,5 +32,5 @@
   if (input == NULL) {
     if (!test)
-      Log() << Verbose(0) << endl << "Unable to open " << filename << ", is the directory correct?" << endl;
+      DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << filename << ", is the directory correct?" << endl);
     return false;
   }
@@ -107,7 +109,7 @@
 bool MatrixContainer::InitialiseIndices(class MatrixContainer *Matrix) 
 {
-  Log() << Verbose(0) << "Initialising indices";
+  DoLog(0) && (Log() << Verbose(0) << "Initialising indices");
   if (Matrix == NULL) {
-    Log() << Verbose(0) << " with trivial mapping." << endl;
+    DoLog(0) && (Log() << Verbose(0) << " with trivial mapping." << endl);
     Indices = Malloc<int*>(MatrixCounter + 1, "MatrixContainer::InitialiseIndices: **Indices");
     for(int i=MatrixCounter+1;i--;) {
@@ -117,5 +119,5 @@
     }
   } else {
-    Log() << Verbose(0) << " from other MatrixContainer." << endl;
+    DoLog(0) && (Log() << Verbose(0) << " from other MatrixContainer." << endl);
     if (MatrixCounter != Matrix->MatrixCounter)
       return false;
@@ -156,7 +158,8 @@
 
   input.open(name, ios::in);
-  //Log() << Verbose(0) << "Opening " << name << " ... "  << input << endl;
+  //Log() << Verbose(1) << "Opening " << name << " ... "  << input << endl;
   if (input == NULL) {
-    eLog() << Verbose(0) << endl << "Unable to open " << name << ", is the directory correct?" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << endl << "Unable to open " << name << ", is the directory correct?" << endl);
+    //performCriticalExit();
     return false;
   }
@@ -178,7 +181,9 @@
   }
   //Log() << Verbose(0) << line.str() << endl;
-  //Log() << Verbose(0) << "ColumnCounter[" << MatrixNr << "]: " << ColumnCounter[MatrixNr] << "." << endl;
-  if (ColumnCounter[MatrixNr] == 0)
-    eLog() << Verbose(0) << "ColumnCounter[" << MatrixNr << "]: " << ColumnCounter[MatrixNr] << " from file " << name << ", this is probably an error!" << endl;
+  //Log() << Verbose(1) << "ColumnCounter[" << MatrixNr << "]: " << ColumnCounter[MatrixNr] << "." << endl;
+  if (ColumnCounter[MatrixNr] == 0) {
+    DoeLog(0) && (eLog()<< Verbose(0) << "ColumnCounter[" << MatrixNr << "]: " << ColumnCounter[MatrixNr] << " from file " << name << ", this is probably an error!" << endl);
+    performCriticalExit();
+  }
   
   // scan rest for number of rows/lines
@@ -192,7 +197,9 @@
     }
   }
-  //Log() << Verbose(0) << "RowCounter[" << MatrixNr << "]: " << RowCounter[MatrixNr] << " from file " << name << "." << endl;
-  if (RowCounter[MatrixNr] == 0)
-    eLog() << Verbose(0) << "RowCounter[" << MatrixNr << "]: " << RowCounter[MatrixNr] << " from file " << name << ", this is probably an error!" << endl;
+  //Log() << Verbose(1) << "RowCounter[" << MatrixNr << "]: " << RowCounter[MatrixNr] << " from file " << name << "." << endl;
+  if (RowCounter[MatrixNr] == 0) {
+    DoeLog(0) && (eLog()<< Verbose(0) << "RowCounter[" << MatrixNr << "]: " << RowCounter[MatrixNr] << " from file " << name << ", this is probably an error!" << endl);
+    performCriticalExit();
+  }
 
   // allocate matrix if it's not zero dimension in one direction
@@ -213,12 +220,11 @@
       input.getline(filename, 1023);
       stringstream lines(filename);
-      //Log() << Verbose(0) << "Matrix at level " << j << ":";// << filename << endl;
+      //Log() << Verbose(2) << "Matrix at level " << j << ":";// << filename << endl;
       for(int k=skipcolumns;k--;)
         lines >> filename;
       for(int k=0;(k<ColumnCounter[MatrixNr]) && (!lines.eof());k++) {
         lines >> Matrix[MatrixNr][j][k];
-        //Log() << Verbose(0) << " " << setprecision(2) << Matrix[MatrixNr][j][k];;
+        //Log() << Verbose(1) << " " << setprecision(2) << Matrix[MatrixNr][j][k] << endl;
       }
-      //Log() << Verbose(0) << endl;
       Matrix[MatrixNr][ RowCounter[MatrixNr] ] = Malloc<double>(ColumnCounter[MatrixNr], "MatrixContainer::ParseMatrix: *Matrix[RowCounter[MatrixNr]][]");
       for(int j=ColumnCounter[MatrixNr];j--;)
@@ -226,5 +232,5 @@
     }
   } else {
-    eLog() << Verbose(0) << "ERROR: Matrix nr. " << MatrixNr << " has column and row count of (" << ColumnCounter[MatrixNr] << "," << RowCounter[MatrixNr] << "), could not allocate nor parse!" << endl; 
+    DoeLog(1) && (eLog()<< Verbose(1) << "Matrix nr. " << MatrixNr << " has column and row count of (" << ColumnCounter[MatrixNr] << "," << RowCounter[MatrixNr] << "), could not allocate nor parse!" << endl); 
   }
   input.close();
@@ -263,5 +269,5 @@
   input.open(file.str().c_str(), ios::in);
   if (input == NULL) {
-    Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl;
+    DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl);
     return false;
   }
@@ -272,7 +278,7 @@
   }
   input.close();
-  Log() << Verbose(0) << "Determined " << MatrixCounter << " fragments." << endl;
-
-  Log() << Verbose(0) << "Parsing through each fragment and retrieving " << prefix << suffix << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Determined " << MatrixCounter << " fragments." << endl);
+
+  DoLog(0) && (Log() << Verbose(0) << "Parsing through each fragment and retrieving " << prefix << suffix << "." << endl);
   Header = ReAlloc<char*>(Header, MatrixCounter + 1, "MatrixContainer::ParseFragmentMatrix: **Header"); // one more each for the total molecule
   Matrix = ReAlloc<double**>(Matrix, MatrixCounter + 1, "MatrixContainer::ParseFragmentMatrix: ***Matrix"); // one more each for the total molecule
@@ -427,5 +433,6 @@
               //Log() << Verbose(0) << "Corresponding index in CurrentFragment is " << m << "." << endl;
               if (m > RowCounter[ KeySets.OrderSet[Order][CurrentFragment] ]) {
-                eLog() << Verbose(0) << "In fragment No. " << KeySets.OrderSet[Order][CurrentFragment]   << " current force index " << m << " is greater than " << RowCounter[ KeySets.OrderSet[Order][CurrentFragment] ] << "!" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "In fragment No. " << KeySets.OrderSet[Order][CurrentFragment]   << " current force index " << m << " is greater than " << RowCounter[ KeySets.OrderSet[Order][CurrentFragment] ] << "!" << endl);
+                performCriticalExit();
                 return false;
               }
@@ -462,5 +469,5 @@
   char *FragmentNumber = NULL;
 
-  Log() << Verbose(0) << "Writing fragment files." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Writing fragment files." << endl);
   for(int i=0;i<MatrixCounter;i++) {
     stringstream line;
@@ -470,5 +477,6 @@
     output.open(line.str().c_str(), ios::out);
     if (output == NULL) {
-      eLog() << Verbose(0) << "Unable to open output energy file " << line.str() << "!" << endl;
+      DoeLog(0) && (eLog()<< Verbose(0) << "Unable to open output energy file " << line.str() << "!" << endl);
+      performCriticalExit();
       return false;
     }
@@ -495,9 +503,10 @@
   stringstream line;
 
-  Log() << Verbose(0) << "Writing matrix values of " << suffix << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Writing matrix values of " << suffix << "." << endl);
   line << name << prefix << suffix;
   output.open(line.str().c_str(), ios::out);
   if (output == NULL) {
-    eLog() << Verbose(0) << "Unable to open output matrix file " << line.str() << "!" << endl;
+    DoeLog(0) && (eLog()<< Verbose(0) << "Unable to open output matrix file " << line.str() << "!" << endl);
+    performCriticalExit();
     return false;
   }
@@ -520,5 +529,5 @@
 bool EnergyMatrix::ParseIndices()
 {
-  Log() << Verbose(0) << "Parsing energy indices." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Parsing energy indices." << endl);
   Indices = Malloc<int*>(MatrixCounter + 1, "EnergyMatrix::ParseIndices: **Indices");
   for(int i=MatrixCounter+1;i--;) {
@@ -579,5 +588,5 @@
     }
     // allocate last plus one matrix
-    Log() << Verbose(0) << "Allocating last plus one matrix with " << (RowCounter[MatrixCounter]+1) << " rows and " << ColumnCounter[MatrixCounter] << " columns." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Allocating last plus one matrix with " << (RowCounter[MatrixCounter]+1) << " rows and " << ColumnCounter[MatrixCounter] << " columns." << endl);
     Matrix[MatrixCounter] = Malloc<double*>(RowCounter[MatrixCounter] + 1, "MatrixContainer::ParseFragmentMatrix: **Matrix[]");
     for(int j=0;j<=RowCounter[MatrixCounter];j++)
@@ -606,5 +615,5 @@
   stringstream line;
 
-  Log() << Verbose(0) << "Parsing force indices for " << MatrixCounter << " matrices." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Parsing force indices for " << MatrixCounter << " matrices." << endl);
   Indices = Malloc<int*>(MatrixCounter + 1, "ForceMatrix::ParseIndices: **Indices");
   line << name << FRAGMENTPREFIX << FORCESFILE;
@@ -612,5 +621,5 @@
   //Log() << Verbose(0) << "Opening " << line.str() << " ... "  << input << endl;
   if (input == NULL) {
-    Log() << Verbose(0) << endl << "Unable to open " << line.str() << ", is the directory correct?" << endl;
+    DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << line.str() << ", is the directory correct?" << endl);
     return false;
   }
@@ -655,5 +664,6 @@
       int j = Indices[ FragmentNr ][l];
       if (j > RowCounter[MatrixCounter]) {
-        eLog() << Verbose(0) << "Current force index " << j << " is greater than " << RowCounter[MatrixCounter] << "!" << endl;
+        DoeLog(0) && (eLog()<< Verbose(0) << "Current force index " << j << " is greater than " << RowCounter[MatrixCounter] << "!" << endl);
+        performCriticalExit();
         return false;
       }
@@ -690,5 +700,5 @@
     input.open(file.str().c_str(), ios::in);
     if (input == NULL) {
-      Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl;
+      DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl);
       return false;
     }
@@ -714,5 +724,5 @@
   
     // allocate last plus one matrix
-    Log() << Verbose(0) << "Allocating last plus one matrix with " << (RowCounter[MatrixCounter]+1) << " rows and " << ColumnCounter[MatrixCounter] << " columns." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Allocating last plus one matrix with " << (RowCounter[MatrixCounter]+1) << " rows and " << ColumnCounter[MatrixCounter] << " columns." << endl);
     Matrix[MatrixCounter] = Malloc<double*>(RowCounter[MatrixCounter] + 1, "MatrixContainer::ParseFragmentMatrix: **Matrix[]");
     for(int j=0;j<=RowCounter[MatrixCounter];j++)
@@ -743,5 +753,5 @@
   stringstream line;
   
-  Log() << Verbose(0) << "Parsing hessian indices for " << MatrixCounter << " matrices." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Parsing hessian indices for " << MatrixCounter << " matrices." << endl);
   Indices = Malloc<int*>(MatrixCounter + 1, "HessianMatrix::ParseIndices: **Indices");
   line << name << FRAGMENTPREFIX << FORCESFILE;
@@ -749,5 +759,5 @@
   //Log() << Verbose(0) << "Opening " << line.str() << " ... "  << input << endl;
   if (input == NULL) {
-    Log() << Verbose(0) << endl << "Unable to open " << line.str() << ", is the directory correct?" << endl;
+    DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << line.str() << ", is the directory correct?" << endl);
     return false;
   }
@@ -792,5 +802,6 @@
       int j = Indices[ FragmentNr ][l];
       if (j > RowCounter[MatrixCounter]) {
-        eLog() << Verbose(0) << "Current hessian index " << j << " is greater than " << RowCounter[MatrixCounter] << ", where i=" << i << ", Order=" << Order << ", l=" << l << " and FragmentNr=" << FragmentNr << "!" << endl;
+        DoeLog(0) && (eLog()<< Verbose(0) << "Current hessian index " << j << " is greater than " << RowCounter[MatrixCounter] << ", where i=" << i << ", Order=" << Order << ", l=" << l << " and FragmentNr=" << FragmentNr << "!" << endl);
+        performCriticalExit();
         return false;
       }
@@ -799,5 +810,6 @@
           int k = Indices[ FragmentNr ][m];
           if (k > ColumnCounter[MatrixCounter]) {
-            eLog() << Verbose(0) << "Current hessian index " << k << " is greater than " << ColumnCounter[MatrixCounter] << ", where m=" << m << ", j=" << j << ", i=" << i << ", Order=" << Order << ", l=" << l << " and FragmentNr=" << FragmentNr << "!" << endl;
+            DoeLog(0) && (eLog()<< Verbose(0) << "Current hessian index " << k << " is greater than " << ColumnCounter[MatrixCounter] << ", where m=" << m << ", j=" << j << ", i=" << i << ", Order=" << Order << ", l=" << l << " and FragmentNr=" << FragmentNr << "!" << endl);
+            performCriticalExit();
             return false;
           }
@@ -851,5 +863,6 @@
               //Log() << Verbose(0) << "Corresponding row index for " << k << " in CurrentFragment is " << m << "." << endl;
               if (m > RowCounter[ KeySets.OrderSet[Order][CurrentFragment] ]) {
-                eLog() << Verbose(0) << "In fragment No. " << KeySets.OrderSet[Order][CurrentFragment]   << " current row index " << m << " is greater than " << RowCounter[ KeySets.OrderSet[Order][CurrentFragment] ] << "!" << endl;
+                DoeLog(0) && (eLog()<< Verbose(0) << "In fragment No. " << KeySets.OrderSet[Order][CurrentFragment]   << " current row index " << m << " is greater than " << RowCounter[ KeySets.OrderSet[Order][CurrentFragment] ] << "!" << endl);
+                performCriticalExit();
                 return false;
               }
@@ -868,5 +881,6 @@
                   //Log() << Verbose(0) << "Corresponding column index for " << l << " in CurrentFragment is " << n << "." << endl;
                   if (n > ColumnCounter[ KeySets.OrderSet[Order][CurrentFragment] ]) {
-                    eLog() << Verbose(0) << "In fragment No. " << KeySets.OrderSet[Order][CurrentFragment]   << " current column index " << n << " is greater than " << ColumnCounter[ KeySets.OrderSet[Order][CurrentFragment] ] << "!" << endl;
+                    DoeLog(0) && (eLog()<< Verbose(0) << "In fragment No. " << KeySets.OrderSet[Order][CurrentFragment]   << " current column index " << n << " is greater than " << ColumnCounter[ KeySets.OrderSet[Order][CurrentFragment] ] << "!" << endl);
+                    performCriticalExit();
                     return false;
                   }
@@ -916,5 +930,5 @@
     input.open(file.str().c_str(), ios::in);
     if (input == NULL) {
-      Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl;
+      DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl);
       return false;
     }
@@ -938,5 +952,5 @@
   
     // allocate last plus one matrix
-    Log() << Verbose(0) << "Allocating last plus one matrix with " << (RowCounter[MatrixCounter]+1) << " rows and " << ColumnCounter[MatrixCounter] << " columns." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Allocating last plus one matrix with " << (RowCounter[MatrixCounter]+1) << " rows and " << ColumnCounter[MatrixCounter] << " columns." << endl);
     Matrix[MatrixCounter] = Malloc<double*>(RowCounter[MatrixCounter] + 1, "MatrixContainer::ParseFragmentMatrix: **Matrix[]");
     for(int j=0;j<=RowCounter[MatrixCounter];j++)
@@ -993,5 +1007,5 @@
 
   FragmentCounter = FCounter;
-  Log() << Verbose(0) << "Parsing key sets." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Parsing key sets." << endl);
   KeySets = Malloc<int*>(FragmentCounter, "KeySetsContainer::ParseKeySets: **KeySets");
   for(int i=FragmentCounter;i--;)
@@ -1000,5 +1014,5 @@
   input.open(file.str().c_str(), ios::in);
   if (input == NULL) {
-    Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl;
+    DoLog(0) && (Log() << Verbose(0) << endl << "Unable to open " << file.str() << ", is the directory correct?" << endl);
     return false;
   }
@@ -1034,5 +1048,5 @@
   int Counter;
 
-  Log() << Verbose(0) << "Creating Fragment terms." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Creating Fragment terms." << endl);
   // scan through all to determine maximum order
   Order=0;
@@ -1045,5 +1059,5 @@
       Order = Counter;
   }
-  Log() << Verbose(0) << "Found Order is " << Order << "." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Found Order is " << Order << "." << endl);
 
   // scan through all to determine fragments per order
@@ -1059,5 +1073,5 @@
   }
   for(int i=0;i<Order;i++)
-    Log() << Verbose(0) << "Found No. of Fragments of Order " << i+1 << " is " << FragmentsPerOrder[i] << "." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Found No. of Fragments of Order " << i+1 << " is " << FragmentsPerOrder[i] << "." << endl);
 
   // scan through all to gather indices to each order set
@@ -1075,12 +1089,12 @@
     FragmentsPerOrder[Counter-1]++;
   }
-  Log() << Verbose(0) << "Printing OrderSet." << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Printing OrderSet." << endl);
   for(int i=0;i<Order;i++) {
     for (int j=0;j<FragmentsPerOrder[i];j++) {
-      Log() << Verbose(0) << " " << OrderSet[i][j];
-    }
-    Log() << Verbose(0) << endl;
-  }
-  Log() << Verbose(0) << endl;
+      DoLog(0) && (Log() << Verbose(0) << " " << OrderSet[i][j]);
+    }
+    DoLog(0) && (Log() << Verbose(0) << endl);
+  }
+  DoLog(0) && (Log() << Verbose(0) << endl);
 
 
Index: src/periodentafel.cpp
===================================================================
--- src/periodentafel.cpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/periodentafel.cpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -9,4 +9,5 @@
 #include <iomanip>
 #include <fstream>
+#include <cstring>
 
 #include "element.hpp"
@@ -48,5 +49,5 @@
   pointer->sort = &pointer->Z;
   if (pointer->Z < 1 && pointer->Z >= MAX_ELEMENTS)
-    Log() << Verbose(0) << "Invalid Z number!\n";
+    DoLog(0) && (Log() << Verbose(0) << "Invalid Z number!\n");
   return add(pointer, end);
 };
@@ -103,5 +104,5 @@
   int Z;
   do {
-    Log() << Verbose(0) << "Atomic number Z: ";
+    DoLog(0) && (Log() << Verbose(0) << "Atomic number Z: ");
     cin >> Z;
     walker = this->FindElement(Z);  // give type
@@ -117,16 +118,16 @@
   element *walker = NULL;
   int Z = -1;
-  Log() << Verbose(0) << "Atomic number: " << Z << endl;
+  DoLog(0) && (Log() << Verbose(0) << "Atomic number: " << Z << endl);
   cin >> Z;
   walker = FindElement(Z);
   if (walker == NULL) {
-    Log() << Verbose(0) << "Element not found in database, please enter." << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Element not found in database, please enter." << endl);
     walker = new element;
     walker->Z = Z;
-    Log() << Verbose(0) << "Mass: " << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Mass: " << endl);
     cin >> walker->mass;
-    Log() << Verbose(0) << "Name [max 64 chars]: " << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Name [max 64 chars]: " << endl);
     cin >> walker->name;
-    Log() << Verbose(0) << "Short form [max 3 chars]: " << endl;
+    DoLog(0) && (Log() << Verbose(0) << "Short form [max 3 chars]: " << endl);
     cin >> walker->symbol;
     periodentafel::AddElement(walker);
@@ -197,5 +198,5 @@
     infile.getline(header1, MAXSTRINGSIZE);
     infile.getline(header2, MAXSTRINGSIZE); // skip first two header lines
-    Log() << Verbose(0) <<  "Parsed elements:";
+    DoLog(0) && (Log() << Verbose(0) <<  "Parsed elements:");
     while (!infile.eof()) {
       element *neues = new element;
@@ -219,15 +220,15 @@
       //infile >> ws;
       infile >> ws;
-      Log() << Verbose(0) << " " << neues->symbol;
+      DoLog(0) && (Log() << Verbose(0) << " " << neues->symbol);
       //neues->Output((ofstream *)&cout);
       if ((neues->Z > 0) && (neues->Z < MAX_ELEMENTS))
         periodentafel::AddElement(neues);
       else {
-        Log() << Verbose(0) << "Could not parse element: ";
+        DoLog(0) && (Log() << Verbose(0) << "Could not parse element: ");
         neues->Output((ofstream *)&cout);
         delete(neues);
       }
     }
-    Log() << Verbose(0) << endl;
+    DoLog(0) && (Log() << Verbose(0) << endl);
     infile.close();
     infile.clear();
@@ -313,5 +314,5 @@
 
   if (!otherstatus)
-    eLog() << Verbose(0) << "WARNING: Something went wrong while parsing the other databases!" << endl;
+    DoeLog(2) && (eLog()<< Verbose(2) << "Something went wrong while parsing the other databases!" << endl);
 
   return status;
Index: src/stackclass.hpp
===================================================================
--- src/stackclass.hpp	(revision 6056f1f6a543f7dbfa9dde0b7705d6820addf1c4)
+++ src/stackclass.hpp	(revision 6cd16bc4b2635b48c1eb855a13b887a00af82259)
@@ -72,5 +72,5 @@
     return true;
   } else {
-    eLog() << Verbose(0) << "ERROR: Stack is full, " << "Stack: CurrentLastEntry " << CurrentLastEntry<< "\tCurrentFirstEntry " << CurrentFirstEntry << "\tNextFreeField " << NextFreeField << "\tEntryCount " << EntryCount << "!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Stack is full, " << "Stack: CurrentLastEntry " << CurrentLastEntry<< "\tCurrentFirstEntry " << CurrentFirstEntry << "\tNextFreeField " << NextFreeField << "\tEntryCount " << EntryCount << "!" << endl);
     return false;
   }
@@ -87,5 +87,5 @@
     Walker = StackList[CurrentFirstEntry];
     if (Walker == NULL)
-      eLog() << Verbose(0) << "ERROR: Stack's field is empty!" << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << "Stack's field is empty!" << endl);
     StackList[CurrentFirstEntry] = NULL;
     if (CurrentFirstEntry != CurrentLastEntry) { // hasn't last item been popped as well?
@@ -96,5 +96,5 @@
     }
   } else
-    eLog() << Verbose(0) << "ERROR: Stack is empty!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Stack is empty!" << endl);
   return Walker;
 };
@@ -111,10 +111,10 @@
     StackList[CurrentLastEntry] = NULL;
     if (Walker == NULL)
-      eLog() << Verbose(0) << "ERROR: Stack's field is empty!" << endl;
+      DoeLog(1) && (eLog()<< Verbose(1) << "Stack's field is empty!" << endl);
     NextFreeField = CurrentLastEntry;
     if (CurrentLastEntry != CurrentFirstEntry)  // has there been more than one item on stack
       CurrentLastEntry = (CurrentLastEntry + (EntryCount-1)) % EntryCount; // step back from current free field to last (modulo does not work in -1, thus go EntryCount-1 instead)
   } else {
-    eLog() << Verbose(0) << "ERROR: Stack is empty!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Stack is empty!" << endl);
   }
   return Walker;
@@ -130,10 +130,10 @@
 {
   bool found = false;
-  Log() << Verbose(5) << "First " << CurrentFirstEntry<< "\tLast " << CurrentLastEntry<< "\tNext " << NextFreeField<< "\tCount " << EntryCount<< "." << endl;
+  DoLog(5) && (Log() << Verbose(5) << "First " << CurrentFirstEntry<< "\tLast " << CurrentLastEntry<< "\tNext " << NextFreeField<< "\tCount " << EntryCount<< "." << endl);
   int i=CurrentFirstEntry;
   if (!IsEmpty())
     do {
       if (StackList[i] == ptr) {  // if item found, remove
-        Log() << Verbose(5) << "Item " << *ptr << " was number " << i << " on stack, removing it." << endl;
+        DoLog(5) && (Log() << Verbose(5) << "Item " << *ptr << " was number " << i << " on stack, removing it." << endl);
         found = true;
         StackList[i] = NULL;
@@ -141,8 +141,8 @@
       if ((found) && (StackList[i] != NULL)) {  // means we have to shift (and not the removed item)
         if (i == 0) { // we are down to first item in stack, have to put onto last item
-          Log() << Verbose(5) << "Shifting item 0 to place " << EntryCount-1 << "." << endl;
+          DoLog(5) && (Log() << Verbose(5) << "Shifting item 0 to place " << EntryCount-1 << "." << endl);
           StackList[EntryCount-1] = StackList[0];
         } else {
-          Log() << Verbose(5) << "Shifting item " << i << " to place " << i-1 << "." << endl;
+          DoLog(5) && (Log() << Verbose(5) << "Shifting item " << i << " to place " << i-1 << "." << endl);
           StackList[i-1] = StackList[i];
         }
@@ -151,5 +151,5 @@
     } while (i!=NextFreeField);
   else
-    eLog() << Verbose(0) << "ERROR: Stack is already empty!" << endl;
+    DoeLog(1) && (eLog()<< Verbose(1) << "Stack is already empty!" << endl);
   if (found) {
     NextFreeField = CurrentLastEntry;
